Option Strict On
Imports System.ComponentModel
Imports System.Windows.Forms.Form
Imports System.Data
Imports System.Drawing
Imports System.Threading
Imports System.Runtime.InteropServices
Imports System.Text
Public Class Form1
    Inherits System.Windows.Forms.Form
    Dim mpbo() As PictureBox    'Output PictureBox Control's Array
    Dim mpbof(15) As Boolean
    Dim mpbi() As PictureBox    'Input PictureBox Control's Array

    Dim wTotalBoards As Short
    Dim wCardType As Short
    Dim wCardAddress As Short
    Dim CardAddr0, CardAddr1, CardAddr2 As Short
    Dim CardAddr3, CardAddr4, CardAddr5 As Short
    Dim wInitialCode, wRtn As Short
    Dim wPort As Short, wSAn As Short, wRAn As Short
    Dim wBoardNo As Short



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        mpbo = CType(ControlArrayUtils.getControlArray(Me.gbxOutput, "pbOut"), PictureBox())
        mpbi = CType(ControlArrayUtils.getControlArray(Me.gbxInput, "pbIn"), PictureBox())
        Dim i As Short
        For i = 1 To 16
            mpbo(i).Image = My.Resources.gray
            mpbi(i).Image = My.Resources.gray
            mpbo(i).Enabled = False
            mpbof(i - 1) = False
            mpbi(i).Enabled = False
            mpbo(i).SizeMode = PictureBoxSizeMode.StretchImage
            mpbi(i).SizeMode = PictureBoxSizeMode.StretchImage
            AddHandler mpbo(i).Click, AddressOf SignOutput

        Next

        '********************************************************************
        '* NOTICE: call FRB_DriverInit() to initialize the driver.          *
        '* Initial the device driver, and return the board number in the PC *
        '********************************************************************
        wInitialCode = FRB_DriverInit(wTotalBoards)

        If wInitialCode <> FRB_NoError Then
            MsgBox("Driver Open Error !!!")
            btnActive.Enabled = False
            Exit Sub
        Else
            btnActive.Enabled = True
        End If

      
        If (wTotalBoards < 1) Then
            MsgBox("Find Card Error!!")
            btnActive.Enabled = False

        Else
            tbxTotal.Text = Str(wTotalBoards)
            nudActive.Maximum = wTotalBoards - 1
            nudActive.Minimum = 0
            'tbxAddr.Text = Hex(PIODA_GetBaseAddress(CShort(nudActive.Value)))
        End If
        tbxOutput.Text = CStr(0)
        wPort = CShort(Val(cbxPort.Text))
        wSAn = CShort(Val(cbxSan.Text))
        wRAn = CShort(Val(cbxRan.Text))

        ' FRB_SendSA(wPort, wSAn, 0) 'Output 0x0


    End Sub

    Private Sub btnActive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnActive.Click
        Dim i As Integer
      
   
        If btnActive.Text = "&Stop" Then
            Timer1.Enabled = False

            btnExit.Enabled = True
            btnActive.Text = "&Active"
            btnOutput.Enabled = False
            btnClear.Enabled = False
            btnTest.Enabled = False
            btnOpen.Enabled = False

            cbxPort.Enabled = True
            cbxRan.Enabled = True
            cbxSan.Enabled = True

            For i = 1 To 16
                mpbo(i).Enabled = False
                mpbi(i).Enabled = False
            Next
            Exit Sub
        End If

        wPort = CShort(Val(cbxPort.Text))
        wSAn = CShort(Val(cbxSan.Text))
        wRAn = CShort(Val(cbxRan.Text))
        wBoardNo = CShort(Me.nudActive.Value)

        btnActive.Text = "&Stop"

        For i = 1 To 16
            mpbo(i).Enabled = True
            mpbi(i).Enabled = True
        Next
        Timer1.Enabled = True
        btnExit.Enabled = False
        btnOutput.Enabled = True
        btnClear.Enabled = True
        btnTest.Enabled = True
        btnOpen.Enabled = True
        cbxPort.Enabled = False
        cbxRan.Enabled = False
        cbxSan.Enabled = False
    End Sub

    Private Sub nudActive_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudActive.ValueChanged
        'tbxAddr.Text = Hex(PIODA_GetBaseAddress(CShort(nudActive.Value)))

    End Sub

    '//For picturebox control array Handle, and Digital Output control
    Private Sub SignOutput(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim i As Short

        i = CShort(DirectCast(sender, PictureBox).Name.Remove(0, 5))

        mpbof(i - 1) = Not mpbof(i - 1)

        If mpbof(i - 1) = False Then
            mpbo(i).Image = My.Resources.gray
        Else
            mpbo(i).Image = My.Resources.red
        End If

       

        Dim DoVal As UShort
        Dim index As UShort
        DoVal = 0

        For index = 0 To 15
            If mpbof(index) Then
                DoVal = DoVal Or CUShort(1 << index)
            End If
        Next

        '********************************************************************
        '* NOTICE: call FRB_SendSA()  Digital Output                          *
        '*                                                                  *
        '********************************************************************

        FRB_SendSABoard(wBoardNo, wPort, wSAn, DoVal)
        tbxOutput.Text = Hex(DoVal)

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim index As Integer
        Dim DIVal As UShort

        '********************************************************************
        '* NOTICE: call FRB_ReceiveRA()  Digital Input                      *
        '*                                                                  *
        '********************************************************************

        wRtn = FRB_ReceiveRABoard(wBoardNo, wPort, wRAn, DIVal)
        Me.Text = Str(wRtn)
        tbxInput.Text = Hex(DIVal)
        'Me.Text = Str(DIVal)

        For index = 1 To 16
            If CBool(DIVal And (1 << (index - 1))) Then
                mpbi(index).Image = My.Resources.red
            Else
                mpbi(index).Image = My.Resources.gray
            End If
        Next



        Application.DoEvents()
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        '********************************************************************
        '* NOTICE: call FRB_DriverClose() to release driver resourc         *
        '*                                                                  *
        '********************************************************************
        FRB_DriverClose()
        End
    End Sub

    Private Sub tbxOutput_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbxOutput.GotFocus
        Me.ToolTip1.Show("Please Keyin DO value from 0000 to FFFF!!", tbxOutput, 20, 20, 2000)
    End Sub

    Private Sub tbxOutput_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles tbxOutput.KeyPress

        If Char.IsLetter(e.KeyChar) Then
            If Not ((e.KeyChar >= "A" And e.KeyChar <= "F") Or (e.KeyChar >= "a" And e.KeyChar <= "f")) Then
                e.KeyChar = ChrW(0)
            End If

        End If
    End Sub

    Private Sub tbxOutput_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbxOutput.Validating
        If Val(tbxOutput.Text) > &HFFFF Or Val(tbxOutput.Text) < 0 Or tbxOutput.Text.Length > 4 Then
            e.Cancel = True
            MsgBox("Please enter value at 0~FFFF")
        End If
    End Sub

    Private Sub btnOutput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOutput.Click
        Dim index As Integer
        FRB_SendSABoard(wBoardNo, wPort, wSAn, CUShort("&H" + tbxOutput.Text))

        For index = 1 To 16
            If CBool(CInt("&H" + tbxOutput.Text) And (1 << (index - 1))) Then
                mpbo(index).Image = My.Resources.red
                mpbof(index - 1) = True
            Else
                mpbo(index).Image = My.Resources.gray
                mpbof(index - 1) = False
            End If
        Next

        Application.DoEvents()
    End Sub
    
   
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        tbxOutput.Text = "0"
        btnOutput_Click(sender, e)
    End Sub

    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click

        tbxOutput.Text = "FFFF"
        btnOutput_Click(sender, e)
    End Sub

    Private Sub btnTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTest.Click
        Dim shiftDOVal As Integer

        shiftDOVal = 1
        btnClear_Click(sender, e)
        While shiftDOVal <= &H8000
            tbxOutput.Text = Hex(shiftDOVal)
            btnOutput_Click(sender, e)
            shiftDOVal = shiftDOVal * 2

            Application.DoEvents()
        End While

        tbxOutput.Text = Hex(0)
        btnOutput_Click(sender, e)

    End Sub
End Class
